unit mainunit;

//
// 0.1 erste Version
// + Credentials testen
// + variable Buttons
// 0.20
// + Menue, Statusbar
// 0.22
// + Austeilen/Einsammeln
// + Mausdienst
// 0.30
// + Mausdienst über UDP
// + Spaltenanzahl variabel
// + Close mit disconnect
// 0.41
// + mit Auth per Host
// + Reset Room beim Beenden
// 0.42
// - useSSL zum Server
// - WOL
//
//
//
//


{$mode objfpc}{$H+}

interface


uses
  Classes, SysUtils, FileUtil, lNetComponents, Forms, Controls, Graphics,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, Menus, Inifiles, Process,
  base, lNet, loginunit, lcommon, AusteilUnit, Nachrichtenunit, EinsammelUnit,
  Debugunit;

Const
  Version   = '0.42';

type

  { THauptfenster }

  THauptfenster = class(TForm)
    BT_Austeilen: TBitBtn;
    BT_D_Green: TBitBtn;
    BT_D_red: TBitBtn;
    BT_Einsammeln: TBitBtn;
    BT_I_green: TBitBtn;
    BT_I_red: TBitBtn;
    BT_L_green: TBitBtn;
    BT_L_red: TBitBtn;
    BT_R_green: TBitBtn;
    BT_R_red: TBitBtn;
    BT_U_aktiv: TBitBtn;
    BT_U_frei: TBitBtn;
    LTCP_zum_Server: TLTCPComponent;
    LTCP_PC: TLTCPComponent;
    LUDP_PC: TLUDPComponent;
    MainMenu1: TMainMenu;
    IT_Programm: TMenuItem;
    IT_Beenden: TMenuItem;
    IT_Info: TMenuItem;
    IT_Reset: TMenuItem;
    IT_debugWindow: TMenuItem;
    IT_GIPS: TMenuItem;
    IT_GROO: TMenuItem;
    IT_GLIN: TMenuItem;
    IT_GDRU: TMenuItem;
    IT_debug: TMenuItem;
    IT_freigeben: TMenuItem;
    IT_logout: TMenuItem;
    IT_Reboot: TMenuItem;
    IT_Poweroff: TMenuItem;
    IT_nachricht: TMenuItem;
    IT_Befehl: TMenuItem;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure BT_EinsammelnClick(Sender: TObject);
    procedure BT_AusteilenClick(Sender: TObject);
    procedure BT_I_Click(Sender: TObject);
    procedure BT_D_Click(Sender: TObject);
    procedure BT_L_Click(Sender: TObject);
    procedure BT_R_Click(Sender: TObject);
    procedure BT_U_Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure IT_BeendenClick(Sender: TObject);
    procedure IT_BefehlClick(Sender: TObject);
    procedure IT_debugWindowClick(Sender: TObject);
    procedure IT_freigebenClick(Sender: TObject);
    procedure IT_GDRUClick(Sender: TObject);
    procedure IT_GIPSClick(Sender: TObject);
    procedure IT_GLINClick(Sender: TObject);
    procedure IT_GROOClick(Sender: TObject);
    procedure IT_InfoClick(Sender: TObject);
    procedure IT_nachrichtClick(Sender: TObject);
    procedure IT_xxx_Click(Sender: TObject);
    procedure IT_ResetClick(Sender: TObject);
    procedure LTCP_PCConnect(aSocket: TLSocket);
    procedure LTCP_zum_ServerConnect(aSocket: TLSocket);
    procedure LTCP_zum_ServerReceive(aSocket: TLSocket);
    procedure LUDP_PCError(const msg: string; aSocket: TLSocket);
    procedure LUDP_PCReceive(aSocket: TLSocket);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    xpos,ypos    : integer;
    BT_pos           : Array[1..BT_max] of Integer;
    BT_green, BT_red : Array[1..BT_max] of TBitBtn;
    Spalten : integer;
    FixPos           : Boolean;
    MyIP, ServerIP, MyRoom, MyComputerName   : String;
    MyDrucker : String;
    SKPort, MDPort   : Integer;
    SKuseAuth        : Integer;
    SKRetryAuth      : Boolean;
    MDuseAuth        : Boolean;
    MyPass             : String;
    Con_Status, debug  : Boolean;
    SBar,RROnStart,RROnEnd     : Boolean;
    Menue              : Boolean;
    SendeMessage,SendeStatus : String;
    MitUhr : Boolean;
    LTCP_Status, LTCP_Befehl : String;
    useSSL : Boolean;
    UDP_mode : Boolean;
    MausDienstPass: String;

    M_Hoehe, S_Hoehe, BT_anz, BT_hoehe, BT_breite : Integer;
    Form_width, Form_height : integer;

    IPListe : TStringList;

    Procedure Benutzerabfrage;
    Function Sende_MausDienst_Befehl(IP, Befehl: String) : String;
    Procedure LogMessage(msg : String);

  public
    { public declarations }
  end;
Const
  Programm_sec     = 'Programm';
    Name_entry     = 'Name';
    Port_entry     = 'Port';
    width_entry    = 'Width';
    height_entry   = 'Height';
    xpos_entry     = 'xpos';
    ypos_entry     = 'ypos';
    Border_entry   = 'BorderStyle';
    HFarbe_entry   = 'Hintergrundfarbe';
    FixPos_entry   = 'FixedPosition';
    Debug_entry    = 'debug';
    StatusBar_entry = 'StatusBarVisible';
    Menue_entry     = 'MenueVisible';
    ServerIP_entry  = 'ServerIP';
    RROnStart_entry = 'ResetRoomOnStart';
    RROnEnd_entry   = 'ResetRoomOnEnd';

    I_entry      = 'InternetButton';
    R_entry      = 'IntranetButton';
    U_entry      = 'URLFilterButton';
    D_entry      = 'DruckerButton';
    A_entry      = 'AusteilenButton';
    E_entry      = 'EinsammelnButton';
    L_entry      = 'ScreenLockButton';
    Spalten_entry  = 'Spalten';

  MausDienst_sec   = 'MausDienst';
    UseSSL_entry   = 'UseSSL';    // Zum linuxmuster-net Server
    UseAuth_entry  = 'UseAuth';
    mitUhr_entry   = 'mitUhr';
    Nachrichtvisible_entry = 'SendeNachrichtVisible';
    Befehlvisible_entry    = 'SendeBefehlVisible';

  IniFileName = 'mini_sk.cfg';
  DefMausDienstPassName = 'md.pass';

var
  Hauptfenster: THauptfenster;
  msg1, msg2 : String;

implementation

{$R *.lfm}

{ THauptfenster }

procedure THauptfenster.FormCreate(Sender: TObject);
Var
  Inifile      : TIniFile;
  FP, IniFilePfad,BStyle : String;
  MDPassPfad   : String;
  Datei        : TStringList;
  n,m,i,xx,yy  : integer;
  b1,b2,b3,b4  : Integer;
  BT_tmp       : Array[1..BT_max] of Integer;
  NachrichtVisible, BefehlVisible : Boolean;

begin
  UDP_mode := false;
  msg1 :=''; msg2 :='' ;
  Timer1.Enabled := false;
  Timer2.Enabled := false;    Timer2.Interval:=5000;
  Con_Status := false;
  SKPort := DefSKPort;
  debug  := false;
  Menue  := false;
  ServerIP :='';
  MyRoom   :='';
  MyDrucker :='';
  MDuseAuth  := true;
  SKRetryAuth := false;
  useSSL   := false;
  MyComputerName := GetComputername;
  IPListe := TStringList.create;
  FP := ExtractFilePath(Application.ExeName);
  IniFilePfad := FP + IniFileName;
  IniFile := TIniFile.Create(IniFilePfad);
  Try with IniFile do
      Begin
          caption     := ReadString (Programm_sec,Name_entry,'Mini-SK');
          SKPort      := ReadInteger(Programm_sec,Port_entry,DefSKPort);
          SKuseAuth   := ReadInteger(Programm_sec,useAuth_entry,1);
          xpos        := ReadInteger(Programm_sec,xpos_entry,-20);
          ypos        := ReadInteger(Programm_sec,ypos_entry,20);
          BStyle      := lowercase(ReadString (Programm_sec,Border_entry,'single'));
          if BStyle = 'single' then BorderStyle := bsSingle
                               else BorderStyle := bsNone;
          Color       := ReadInteger(Programm_sec,HFarbe_entry,clDefault);
          FixPos      := Boolean(ReadInteger(Programm_sec,FixPos_entry,1));
          Debug       := Boolean(ReadInteger(Programm_sec,Debug_entry,0));
          SBar        := Boolean(ReadInteger(Programm_sec,StatusBar_entry,1));
          Menue       := Boolean(ReadInteger(Programm_sec,Menue_entry,0));
          RROnStart   := Boolean(ReadInteger(Programm_sec,RROnStart_entry,0));
          RROnEnd     := Boolean(ReadInteger(Programm_sec,RROnStart_entry,0));
          ServerIP    := ReadString (Programm_sec,ServerIP_entry,'');

          BT_pos[1]   := ReadInteger(Programm_sec,I_entry,1);
          BT_pos[2]   := ReadInteger(Programm_sec,R_entry,2);
          BT_pos[3]   := ReadInteger(Programm_sec,U_entry,3);
          BT_pos[4]   := ReadInteger(Programm_sec,L_entry,4);
          BT_pos[5]   := ReadInteger(Programm_sec,D_entry,5);
          BT_pos[6]   := ReadInteger(Programm_sec,A_entry,6);
          BT_pos[7]   := ReadInteger(Programm_sec,E_entry,7);
          Spalten     := ReadInteger(Programm_sec,Spalten_entry,1);

          MDPort      := ReadInteger(Mausdienst_sec,Port_entry,DefMDPort);
          MDuseAuth   := Boolean(ReadInteger(Mausdienst_sec,useAuth_entry,1));
          useSSL      := Boolean(ReadInteger(Mausdienst_sec,useSSL_entry,0));
          mitUhr      := Boolean(ReadInteger(Mausdienst_sec,mitUhr_entry,1));
          NachrichtVisible:= Boolean(ReadInteger(Mausdienst_sec,NachrichtVisible_entry,1));
          BefehlVisible   := Boolean(ReadInteger(Mausdienst_sec,BefehlVisible_entry,0));

          msg1 := 'Konfigurationsdatei geladen: '+IniFilePfad;
      end
    finally
      IniFile.free;
    end;
    ///////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////
    if MDuseAuth and (BT_pos[4]>0) then  // Mausdiensts-Button mit auth
      Begin
        MDPassPfad := FP + DefMausDienstPassName;
        if FileExists(MDPassPfad) then
          Begin
            Datei := TStringList.create;
            Datei.LoadFromFile(MDPassPfad);
            MausDienstPass := Trim(Datei.text);
            Datei.free;
            msg2 := 'MausDienst-Passwort geladen: '+MDPassPfad;
          end
        else
          Begin
            if MDuseAuth and debug then ShowMessage('Die Datei mit dem MausDienst-Passwort wurde nicht gefunden!'+ret+ret+MDPassPfad);
          end;
      end;
  BT_anz :=0;
  for n := 1 to BT_max do
    Begin
      if BT_pos[n] <=0 then BT_pos[n] := 0
                       else inc(BT_anz);
      Bt_tmp[n] :=0;
    end;
  if BT_anz=0 then
    Begin
      BT_pos[1] := 1;
      BT_anz    := 1;
    end;
  for n := 1 to BT_max do
    Begin
      i := 0;
      for m := 1 to BT_max do
        if BT_pos[m]>0  then
          Begin
            if i=0 then i := m
                   else if (BT_pos[m]<BT_pos[i]) then i := m;
          end;
      BT_tmp[n] :=i;
      if i >0 then BT_pos[i] :=0;
    end;
  for n := 1 to BT_max do if BT_tmp[n]>0 then BT_pos[BT_tmp[n]]:= n;
  //ShowMessage('POS: '+IntToStr(BT_pos[1])+'-'+IntToStr(BT_pos[2])+'-'+IntToStr(BT_pos[3])+'-'+IntToStr(BT_pos[4])+ret+
  //            'TMP: '+IntToStr(BT_tmp[1])+'-'+IntToStr(BT_tmp[2])+'-'+IntToStr(BT_tmp[3])+'-'+IntToStr(BT_tmp[4]));

  BT_green[1] := BT_I_green;     BT_red[1] := BT_I_red;
  BT_green[2] := BT_R_green;     BT_red[2] := BT_R_red;
  BT_green[3] := BT_U_aktiv;     BT_red[3] := BT_U_frei;
  BT_green[4] := BT_L_green;     BT_red[4] := BT_L_red;
  BT_green[5] := BT_D_green;     BT_red[5] := BT_D_red;
  BT_green[6] := BT_austeilen;   BT_red[6] := nil; //BT_austeilen;
  BT_green[7] := BT_einsammeln;  BT_red[7] := nil; //BT_einsammeln;

  for n := 1 to BT_max do
    Begin
      If (BT_pos[n]=0) then
        Begin
          BT_green[n].enabled := false;
          BT_green[n].visible := false;
          if (BT_red[n]<>nil) then
            Begin
              BT_red[n].enabled   := false;
              BT_red[n].visible   := false;
            end;
        end
    end;
  BT_hoehe := BT_green[1].Height;
  BT_breite:= BT_green[1].Width;
  if Spalten>BT_anz then Spalten:=BT_anz;
  if Spalten<1 then Spalten :=1;
  xx := 1;
  yy := 1;
  i := 0;
  for m := 1 to BT_max do
    Begin
      n := BT_tmp[m];
      if (n>0) then
        Begin
          inc(i);
          BT_green[n].top := 8+(yy-1)*(10+BT_Hoehe);
          BT_green[n].left := 10+(xx-1)*(10+BT_Breite);
          BT_green[n].visible := true;
          BT_green[n].TabOrder:=i*2-1;
          BT_green[n].enabled := false;
          if (BT_red[n]<>nil) then
            Begin
              BT_red[n].top := BT_green[n].top;
              BT_red[n].Left:= BT_green[n].Left;
              BT_red[n].TabOrder:=i*2;
              BT_red[n].visible   := false;
              BT_red[n].enabled := false;
            end;
          inc(xx);
          if xx>Spalten then
            Begin
              xx := 1;
              if i <  BT_Anz then inc(yy);
            end;
        end;
    end;
  if SBar then
    Begin
      StatusBar.Visible:=True;
      S_Hoehe := StatusBar.Height;
    end
  else
    Begin
      StatusBar.Visible:=false;
      S_Hoehe :=0;
    end;
  if Menue then
    Begin
      M_Hoehe := 17
    end
  else
    Begin
      M_Hoehe := 0;
    end;
  // Höheneinstellung funktioniert nur mit Autosize := true;
  Autosize := true;
  Form_height   := 8+yy*(BT_Hoehe+10)+S_Hoehe; // +M_Hoehe
  Panel1.Height := Form_height;
  height        := Form_height;
  Form_width    := 10+Spalten*(BT_breite+10);
  Panel1.Width  := Form_width;
  width         := Form_width;
  if BefehlVisible then IT_Befehl.visible := true
                   else IT_Befehl.visible := false;
  if NachrichtVisible then IT_Nachricht.visible := true
                      else IT_Nachricht.visible := false;
  if Menue then
    Begin
      IT_Programm.visible := true;
      M_Hoehe := 17
    end
  else
    Begin
      IT_Programm.visible := false;
      M_Hoehe := 0;
    end;
  if debug then
    Begin
      IT_debug.Visible:=True;;
    end
  else
    Begin
      IT_debug.Visible:=false;
    end;
  If FixPos then Timer1.Enabled := True;
  if xpos>0 then
    Begin
      Left := xpos;
    end
  else
    Begin
      Left:=Screen.DesktopWidth+xpos-width;
    end;
  if ypos >0 then
    Begin
      top := ypos;
    end
  else
    Begin
      top:=Screen.DesktopHeight+ypos-Height;
    end;
  if ServerIP='' then
    Begin
      MyIP := IPauslesen;
      if ZerlegeIP(MyIP, b1,b2,b3,b4) then
        Begin
          if (b1=10) and (b2>=16) then
            Begin
              ServerIP := '10.'+IntToStr((b2 div 16)*16)+'.1.1';
            end;
        end;
    end;
// -----------------------------------------------------------------------------------------
end;

procedure THauptfenster.Timer1Timer(Sender: TObject);
begin                                // Timer für automatische Positionierung auf Desktop
  ShowInTaskbar := stnever;
  if xpos>0 then Left := xpos
            else Left := Screen.DesktopWidth+xpos-width;
  if ypos>0 then top  := ypos
            else top  := Screen.DesktopHeight+ypos-Height;
end;

procedure THauptfenster.IT_BeendenClick(Sender: TObject);
begin
  close;
end;


procedure THauptfenster.IT_debugWindowClick(Sender: TObject);
begin
  DebugForm.show;
end;

procedure THauptfenster.IT_freigebenClick(Sender: TObject);
begin
  BT_L_green.Visible:=false;
  BT_L_red.Visible:=true;
  BT_L_Click(nil);
end;

procedure THauptfenster.IT_InfoClick(Sender: TObject);
Var
   s : String;
begin
  s := 'Mini-Schulkonsole (Version '+Version+')'+ret+ret;
  s := s + 'Programmiert von Martin Resch mit Lazarus 1.6, Dez 2016.'+ret+ret;
  s := s + 'Client IP: '+MyIP+ret+'Computername: '+MyComputerName+ret+
  'Server IP: '+ServerIP+ret+'Raum: '+MyRoom+' (mit '+IntToStr(IPListe.count)+' Geräten)'+ret+
  MyDrucker+ret;
  ShowMessage(s);
end;

procedure THauptfenster.IT_nachrichtClick(Sender: TObject);
Var
   Befehl,Nachricht,z   : String;
   n,i          : integer;
begin
  NachrichtenForm.ActiveControl := NachrichtenForm.Nachricht_Memo;
  if NachrichtenForm.ShowModal = mrYes then
    Begin
      Nachricht := NachrichtenForm.Nachricht_Memo.text;
      z := '"''`';
      for i := 1 to length(Nachricht) do
        Begin
          if Pos(Nachricht[i],z)>0 then Nachricht[i] := ' ';
        end;
      Befehl := msg_nachricht+ Nachricht ;
      for n := 0 to IPliste.count-1 do
        Begin
          if (IPListe[n]<>myIP) then
            Begin
              Sende_MausDienst_Befehl(IPListe[n], Befehl);
            end;
        end;
    end;
end;


procedure THauptfenster.IT_BefehlClick(Sender: TObject);
Var
  Befehl : String;
  n      : integer;
begin
  if InputQuery('Befehl an alle PC senden', 'Konsolenbefehl eingeben:', Befehl) then
    Begin
      Befehl := msg_befehl+Trim(Befehl);
      for n := 0 to IPliste.count-1 do
        Begin
          if (IPListe[n]<>myIP) then
            Begin
              Sende_MausDienst_Befehl(IPListe[n], Befehl);
            end;
        end;

    end;
end;

procedure THauptfenster.IT_xxx_Click(Sender: TObject);
Var
   Befehl   : String;
   n,t      : integer;
begin
  t:= (Sender as TMenuItem).Tag;
  Case t of
    0 : Befehl := msg_logout;
    1 : Befehl := msg_reboot;
    2 : Befehl := msg_poweroff;
  end;
  LogMessage('Befehl '+Befehl+' wird an '+IntToStr(IPLIste.count)+' PCs ausgeführt.');
  for n := 0 to IPliste.count-1 do
    Begin
      if (IPListe[n]<>myIP) then
        Begin
          Sende_MausDienst_Befehl(IPListe[n], Befehl);
        end;
    end;
end;

procedure THauptfenster.IT_ResetClick(Sender: TObject);
Var
   n : Integer;
begin
  for n := 1 to BT_max do if BT_Pos[n]>0 then
    Begin
      BT_green[n].enabled := false;
      if (BT_red[n]<>nil) then BT_red[n].enabled := false;
    end;
  SendeStatus  := msg_SRST;
  StatusBar.Panels.Items[0].Text:='Set Room defaults';
  StatusBar.Update;
  LogMessage('Set Room defaults ...');
  SendeMessage := msg_SRST+'%'+MyBenutzer+'%'+MyPass;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;


procedure THauptfenster.LTCP_zum_ServerConnect(aSocket: TLSocket);
begin
  LogMessage('... Connected :-)');
  Con_Status := True;
  if SendeMessage<>'' then
    Begin
      sleep(200);
      aSocket.SendMessage(SendeMessage);
    end;
end;

procedure THauptfenster.LTCP_zum_ServerReceive(aSocket: TLSocket);
Var
  s,t,r,o   : String;
  Befehl    : String;
  Liste, Zeile   : TStringList;
  n       : Integer;
begin
  if aSocket.GetMessage(S) > 0 then
  Begin
    if (SendeStatus=msg_AUTH) then
      Begin
        Timer2.Enabled := false;
        LogMessage('Receive ('+SendeStatus+'): '+S);
        if s ='OK' then
          Begin
            if RRonStart then
              Begin
                SendeStatus  :=msg_SRST;
                StatusBar.Panels.Items[0].Text:='Set Room defaults';
                StatusBar.Update;
                LogMessage('Set Room defaults ...');
                SendeMessage :=msg_SRST+'%'+MyBenutzer+'%'+MyPass;
                Timer2.Interval:=8000;
                Timer2.Enabled := true;
                LTCP_zum_Server.SendMessage(SendeMessage);
              end
            else
              Begin
                SendeStatus  :=msg_GRST;
                StatusBar.Panels.Items[0].Text:='Get Room...';
                StatusBar.Update;
                LogMessage('Get Room ...');
                SendeMessage :=msg_GRST+'%'+MyBenutzer+'%'+MyPass;
                Timer2.Interval:=8000;
                Timer2.Enabled := true;
                LTCP_zum_Server.SendMessage(SendeMessage)
              end;
          end
        else
          Begin
            LTCP_zum_Server.Disconnect(True);
            Sleep(200);
            ShowMessage('ERROR!'+ret+ret+'Authentifizierung fehlgeschlagen!');
            SKRetryAuth:=True;
            FormShow(nil);
          end;
      end
    else if (SendeStatus=msg_GRST) or (SendeStatus=msg_SRST) then
      Begin
        Timer2.Interval:= 5000;
        Timer2.Enabled:=False;
        LogMessage('Receive ('+SendeStatus+'): '+S);
        if s<>'DENY' then
          Begin
            SendeStatus :='';
            Zeile   := TStringList.create;
            Zeile.commatext := s;
            if Zeile.count>0 then r := Zeile[0]
                             else r := s;
            if (Zeile.count =4) then
              Begin
                for n := 1 to 3 do
                  Begin
                    o := lowercase(Zeile[n]);
                    if (BT_pos[n]>0) then
                      Begin
                        if(o = 'on') then
                          Begin
                            BT_green[n].visible := true;
                            BT_red[n].visible := false;
                          end
                        else if (o = 'off') then
                          Begin
                            BT_green[n].Visible:=false;
                            BT_red[n].Visible:=true;
                          end;
                        BT_green[n].enabled := true;
                        BT_red[n].enabled:=true;
                      end;
                  end;
                if (BT_pos[4]>0) then
                  Begin
                    BT_green[4].visible := true;
                    BT_red[4].visible := false;
                    BT_green[4].enabled := true;
                    BT_red[4].enabled:=true;
                  end;
                for n := 6 to BT_max do
                  Begin
                    if (BT_pos[n]>0) then BT_green[n].enabled := True;
                  end;
              end;
            if SBar then StatusBar.Panels.Items[0].Text:=MyBenutzer+' in '+r;
            MyRoom := r;
            IT_Programm.Enabled:=True;
            IT_debug.Enabled := True;;
            Zeile.free;
            SendeStatus  := 'GetIP-start';
            SendeMessage := msg_GIPS+'%'+MyBenutzer+'%'+MyPass;
            Timer2.Enabled:=True;
            LTCP_zum_Server.SendMessage(SendeMessage);
          end
        else
          Begin
            ShowMessage('ERROR!'+ret+ret+'Raum nicht ermittelbar!');
          end;
      end
    else if (sendeStatus='BEENDE') then
      Begin
        LogMessage('Receive ('+SendeStatus+'): '+S);
        Timer2.Enabled:=False;
        close;
      end
    else if (sendeStatus='GetIP-start') then
      Begin
        Timer2.Enabled:=False;
        IPListe.commatext := S;
        LogMessage(IPListe.commatext);
        if (BT_pos[5]>0) then
          Begin
                SendeStatus :=msg_GDST;
                SendeMessage :=msg_GDST;
                Timer2.Enabled:=True;
                LTCP_zum_Server.SendMessage(SendeMessage);
          end;
      end
    else if (sendeStatus=msg_GDST) then
      Begin
        Timer2.Enabled:=False;
        LogMessage('Receive ('+SendeStatus+'): '+S);
        sendeStatus:='';
        if (s <>'KEINE') then
          Begin
            BT_D_green.Enabled := true;
            BT_D_red.Enabled := true;
            if (s = 'ACCEPT') and not BT_D_green.Visible then
              Begin
                BT_D_green.Visible:=true;
                BT_D_red.Visible:=false;
             end
            else if (s = 'REJECT') and BT_D_green.Visible then
              Begin
                BT_D_green.Visible:=false;
                BT_D_red.Visible:=true;
              end;
            MyDrucker := 'Drucker im Raum erkannt.';
          end
        else
          Begin
            BT_D_green.Enabled := false;
            BT_D_red.Enabled := false;
            MyDrucker := 'Keine Drucker im Raum vorhanden.';
            LogMessage(MyDrucker);
          end;
      end
    else if SendeStatus = 'einsammeln-start' then
      Begin
        SendeStatus  := '';
        Timer2.Enabled:=false;
        Liste := TStringList.create;
        Zeile := TStringList.create;
        WSplit(S,Liste);
        t := '';
        for n := 0 to Liste.count-1 do
          Begin
            Zeile.commatext := Liste[n];
            if (Zeile.count=2) and (Zeile[1]<>'-') then
              Begin
                if t='' then t := Zeile[1]
                        else t := t+', '+Zeile[1];
              end;
          end;
        EinsammelForm.UserMemo.Text := t;
        if EinsammelForm.ShowModal = mrYes then
          Begin
            If EinsammelForm.RG_loesch.ItemIndex=0 then
              Begin
                SendeStatus  := msg_EARA;
                SendeMessage := msg_EARA+'%'+MyBenutzer+'%'+MyPass;
              end
            else
              Begin
                SendeStatus  := msg_EARC;
                SendeMessage := msg_EARC+'%'+MyBenutzer+'%'+MyPass;
              end;
            LTCP_zum_Server.SendMessage(SendeMessage);
          end;
        Liste.free;
        Zeile.free;
      end
    else
      Begin
        if SendeStatus = '' then LogMessage('Receive: '+S)
                            else LogMessage('Receive ('+SendeStatus+'): '+S);
        SendeStatus:='';
      end;
  end;
end;

procedure THauptfenster.LUDP_PCError(const msg: string; aSocket: TLSocket);
begin
  LogMessage('LUDP-Fehler: '+msg);
end;

procedure THauptfenster.LUDP_PCReceive(aSocket: TLSocket);
begin
  LogMessage('LUDP-Receive');
end;

procedure THauptfenster.BT_L_Click(Sender: TObject);
Var
  Befehl : String;
  n : Integer;
begin
  if BT_L_green.Visible then
    Begin
      if mitUhr then Befehl := msg_sperrenU
                else Befehl := msg_sperren;
    end
  else
    Begin
      Befehl := msg_freigeben;
    end;
  LogMessage('Befehl '+Befehl+' wird an '+IntToStr(IPLIste.count)+' PCs ausgeführt.');
  BT_L_red.enabled := false;
  BT_L_green.enabled := false;
  for n := 0 to IPliste.count-1 do
    Begin
      if (IPListe[n]<>myIP) then
        Begin
          Sende_MausDienst_Befehl(IPListe[n], Befehl);
        end;
    end;
  //Sleep(3000);
  BT_L_red.enabled := true;
  BT_L_green.enabled := true;
  if BT_L_green.Visible then
            Begin
              BT_L_green.Visible:=false;
              BT_L_red.Visible:=true;
              BT_L_red.SetFocus;
            end
  else
            Begin
              BT_L_green.Visible:=true;
              BT_L_red.Visible:=false;
              BT_L_green.SetFocus;
            end;
end;


Function THauptfenster.Sende_MausDienst_Befehl(IP, Befehl: String) : String;
begin
  if MDUseAuth then LTCP_Befehl := '%'+vtr(MausDienstPass)+'%'+Befehl
               else LTCP_Befehl := Befehl;
  if UDP_mode then
    Begin ////////////////////// UDP /////////////////////
      LUDP_PC.ReuseAddress := true;
      if LUDP_PC.Connect(IP, MDPort) then
        Begin
          LUDP_PC.SendMessage(LTCP_Befehl);
          LogMessage('UDP-gesendet an '+IP+' : '+LTCP_Befehl);
          LUDP_PC.disconnect(True);
        end;
    end
  else
    Begin ////////////////////// TCP /////////////////////
      //LSSLSession.SSLActive:=false;
      LTCP_Status := 'Verbindungsaufbau';
      LTCP_PC.socketNet    := LAF_INET;
      LTCP_PC.ReuseAddress := true;
      LTCP_PC.Timeout:=100;
      if debug and LTCP_PC.Connected Then
        Begin
          LogMessage('LTCP-Statusfehler:'+ret+'Connected=True'+ret+'ABER: Disconnected');
        end;
      LogMessage(LTCP_Status+' - '+IP+':'+IntToStr(MDPort));
      if LTCP_PC.Connect(IP, MDPort) then
        Begin
          //DebugMemo.append('Connect to: '+IP+':'+IntToStr(MausDienstPort));
          Sleep(SleepTime);
          Application.ProcessMessages;
          Sleep(SleepTime);
        end;
    end;
end;


procedure THauptfenster.LTCP_PCConnect(aSocket: TLSocket);
begin
  if LTCP_Status = 'Verbindungsaufbau' then
    Begin
      LTCP_Status := 'senden';
      LogMessage('Connected -> '+LTCP_Status+' - '+aSocket.PeerAddress+' '+LTCP_Befehl);
      LTCP_PC.SendMessage(LTCP_Befehl);
      LTCP_Status := 'gesendet';
      LTCP_Befehl := '';
      LTCP_PC.Disconnect(True);
      LTCP_Status := 'disconnect';
      Sleep(SleepTime);
      //Application.ProcessMessages;
    end
  else
    begin
      LogMessage('Connect-Status ???: '+LTCP_Status+' --- '+aSocket.PeerAddress);
    end;
end;


procedure THauptfenster.Timer2Timer(Sender: TObject);
begin
  Timer2.enabled:=false;
  if SendeStatus=msg_AUTH then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'Authentifizierung fehlgeschlagen!');
    end
  else if (SendeStatus=msg_GRST) then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'Raum nicht ermittelbar!');
    end
  else if (SendeStatus=msg_SRST) or (SendeStatus='BEENDE') then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'Raum nicht auf Default gesetzt!');
    end
  else if SendeStatus=msg_GDST then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'Drucker nicht ermittelbar!');
    end
  else if SendeStatus='einsammeln-start' then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'User-Logins nicht ermittelbar!');
    end
  else if SendeStatus='GetIP-start' then
    Begin
      ShowMessage('ERROR, TIMEOUT!'+ret+ret+'Raum IPs nicht ermittelbar!');
    end
  ;
end;

procedure THauptfenster.FormCloseQuery(Sender: TObject; var CanClose: boolean);
Var n : integer;
begin
  if RROnEnd then
    Begin
      CanClose := false;
      RROnEnd:=false;
      for n := 1 to BT_max do if BT_Pos[n]>0 then
        Begin
          BT_green[n].enabled := false;
          if (BT_red[n]<>nil) then BT_red[n].enabled := false;
        end;
      SendeStatus  := 'BEENDE';
      StatusBar.Panels.Items[0].Text:='Set Room defaults';
      StatusBar.Update;
      LogMessage('Beende: Set Room defaults ...');
      SendeMessage := msg_SRST+'%'+MyBenutzer+'%'+MyPass;
      LTCP_zum_Server.SendMessage(SendeMessage);
    end
  else
    CanClose := True;
end;


procedure THauptfenster.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  IPListe.free;
  LTCP_zum_Server.Disconnect(True);
  Sleep(300);
end;

Procedure THauptfenster.Benutzerabfrage;
Begin
  LoginForm.ED_Name.text := GetBenutzer;
  LoginForm.ED_Pass.text := '';
  if LoginForm.ShowModal = mrCancel then
    Begin
      close;
    end;
  MyBenutzer := Trim(LoginForm.ED_Name.text);
  MyPass := LoginForm.ED_Pass.text;
  LogMessage('User: '+MyBenutzer);
  LogMessage('IP: '+MyIP);
  LogMessage('Server: '+ServerIP);
end;

procedure THauptfenster.FormShow(Sender: TObject);
begin
  if msg1<>'' then LogMessage(msg1);
  if msg2<>'' then LogMessage(msg2);
  MyBenutzer := GetBenutzer;
  if (SKuseAuth=1) or SKRetryAuth then Benutzerabfrage;
  LTCP_zum_Server.ReuseAddress:=True;
  LTCP_zum_Server.SocketNet:=LAF_INET;
  LTCP_zum_Server.Timeout:=100;
  if LTCP_zum_Server.Connect(ServerIP, SKPort) then
    Begin
      LogMessage('Connect Start ...');
    end;
  SendeMessage:= msg_AUTH+'%'+MyBenutzer+'%'+MyPass;
  SendeStatus := msg_AUTH;  StatusBar.Panels.Items[0].Text:='Authentifizierung ...';
  Timer2.enabled := True;
end;

procedure THauptfenster.BT_I_Click(Sender: TObject);
begin
  if not Con_Status then
    Begin
      //ShowMessage('Nicht verbunden!');
      //exit;
    end;
  if BT_I_green.Visible then
    Begin
      LogMessage('Befehl '+msg_INOF+' wird ausgeführt.');
      BT_I_green.Visible:=false;
      BT_I_red.Visible:=true;
      BT_I_red.SetFocus;
      LTCP_zum_Server.SendMessage(msg_INOF+'%'+MyBenutzer+'%'+MyPass);
    end
  else
    Begin
      LogMessage('Befehl '+msg_INON+' wird ausgeführt.');
      BT_I_green.Visible:=true;
      BT_I_red.Visible:=false;
      BT_I_green.SetFocus;
      LTCP_zum_Server.SendMessage(msg_INON+'%'+MyBenutzer+'%'+MyPass)
    end;
end;

procedure THauptfenster.BT_AusteilenClick(Sender: TObject);
begin
  AusteilForm.ShowModal;
  if (AusteilForm.MResult=mrYes) then
    Begin
      SendeStatus  := 'austeilen';
      SendeMessage := msg_AARA+'%'+MyBenutzer+'%'+MyPass;
      LTCP_zum_Server.SendMessage(SendeMessage);
    end;
end;

procedure THauptfenster.BT_EinsammelnClick(Sender: TObject);
begin
  SendeStatus :='einsammeln-start';
  SendeMessage :=msg_GLIN+'%'+MyBenutzer+'%'+MyPass;;
  Timer2.Enabled:=True;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;

procedure THauptfenster.BT_D_Click(Sender: TObject);
begin
  if not Con_Status then
    Begin
      //ShowMessage('Nicht verbunden!');
      //exit;
    end;
  if BT_D_green.Visible then
    Begin
      LogMessage('Befehl '+msg_DROF+' wird ausgeführt.');
      BT_D_green.Visible:=false;
      BT_D_red.Visible:=true;
      BT_D_red.SetFocus;
      LTCP_zum_Server.SendMessage(msg_DROF+'%'+MyBenutzer+'%'+MyPass);
    end
  else
    Begin
      LogMessage('Befehl '+msg_DRON+' wird ausgeführt.');
      BT_D_green.Visible:=true;
      BT_D_red.Visible:=false;
      BT_D_green.SetFocus;
      LTCP_zum_Server.SendMessage(msg_DRON+'%'+MyBenutzer+'%'+MyPass)
    end;
end;


procedure THauptfenster.BT_R_Click(Sender: TObject);
begin
  if not Con_Status then
    Begin
      //ShowMessage('Nicht verbunden!');
      //exit;
    end;
  if BT_R_green.Visible then
    Begin
      LogMessage('Befehl '+msg_IROF+' wird ausgeführt.');
      BT_R_green.Visible:=false;
      BT_R_red.Visible:=true;
      BT_R_red.SetFocus;
      LTCP_zum_Server.SendMessage(msg_IROF+'%'+MyBenutzer+'%'+MyPass);
    end
  else
    Begin
      LogMessage('Befehl '+msg_IRON+' wird ausgeführt.');
      BT_R_green.Visible:=true;
      BT_R_red.Visible:=false;
      BT_R_green.SetFocus;
      LTCP_zum_Server.SendMessage(msg_IRON+'%'+MyBenutzer+'%'+MyPass)
    end;
end;

procedure THauptfenster.BT_U_Click(Sender: TObject);
begin
  if not Con_Status then
    Begin
      //ShowMessage('Nicht verbunden!');
      //exit;
    end;
  if BT_U_aktiv.Visible then
    Begin
      LogMessage('Befehl '+msg_UFOF+' wird ausgeführt.');
      BT_U_aktiv.Visible:=false;
      BT_U_frei.Visible:=true;
      BT_U_frei.SetFocus;
      LTCP_zum_Server.SendMessage(msg_UFOF+'%'+MyBenutzer+'%'+MyPass);
    end
  else
    Begin
      LogMessage('Befehl '+msg_UFON+' wird ausgeführt.');
      BT_U_aktiv.Visible:=true;
      BT_U_frei.Visible:=false;
      BT_U_aktiv.SetFocus;
      LTCP_zum_Server.SendMessage(msg_UFON+'%'+MyBenutzer+'%'+MyPass);
    end;
end;


procedure THauptfenster.IT_GDRUClick(Sender: TObject);
begin
  SendeStatus  := msg_GDRU;
  SendeMessage := msg_GDRU+'%'+MyBenutzer+'%'+MyPass;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;

procedure THauptfenster.IT_GIPSClick(Sender: TObject);
begin
  SendeStatus  := msg_GIPS;
  SendeMessage := msg_GIPS+'%'+MyBenutzer+'%'+MyPass;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;

procedure THauptfenster.IT_GLINClick(Sender: TObject);
begin
  SendeStatus  := msg_GLIN;
  SendeMessage := msg_GLIN+'%'+MyBenutzer+'%'+MyPass;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;

procedure THauptfenster.IT_GROOClick(Sender: TObject);
begin
  SendeStatus  := msg_GROO;
  SendeMessage := msg_GROO+'%'+MyBenutzer+'%'+MyPass;
  LTCP_zum_Server.SendMessage(SendeMessage);
end;

procedure THauptfenster.LogMessage(msg : String);
begin
  if debug then DebugForm.DebugMemo.append(msg);
end;


end.

